﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Invader_ai : MonoBehaviour {
	bool collision_rightwall;
	bool collision_leftwall;
	float speed;
	float speedOne = 1.5f;
	float speedTwo = 2.0f;
	float speedThree = 1.0f;
	int randomNumber;
	bool diffOne, diffTwo;
	public GameObject enemyLazer;
	public AudioClip lazerAudio;
	// Use this for initialization
	void Start () {
		speedOne = 1.5f;
		speedTwo = 2.0f;
		speedThree = 1.0f;
		diffOne = false;
		diffTwo = false;
		randomNumber = Random.Range (0, 50);
		// choose a speed to start
		if (randomNumber > 30) {
			speed = speedOne;
			InvokeRepeating ("ShootLazer", Random.Range (5f, 50f), Random.Range (5f, 50f));
		} else if ((randomNumber < 30) && (randomNumber > 10)) {
			speed = speedThree;
			InvokeRepeating ("ShootLazer", Random.Range (14f, 65f), Random.Range (14f, 65f));
		} else {
			speed = speedTwo;
			InvokeRepeating ("ShootLazer", Random.Range (20f, 70f), Random.Range (20f, 70f));
		}
		collision_leftwall = false;
		collision_rightwall = false;
	}
	
	// Update is called once per frame
	void Update () {
		CheckDifficulty ();
		if (collision_leftwall) {
			// go right
			transform.position += Vector3.right * speed * Time.deltaTime;
		} else if (collision_rightwall) {
			// go left
			transform.position += Vector3.left * speed * Time.deltaTime;
		} else {
			// choose a direction to start
			if (randomNumber > 25) {
				transform.position += Vector3.left * speed * Time.deltaTime;
			} else {
				transform.position += Vector3.right * speed * Time.deltaTime;
			}
		}
	}

	void OnCollisionEnter2D(Collision2D obj) {
		if (obj.gameObject.name == "LeftWall") {
			transform.position += Vector3.down * 20f * Time.deltaTime;
			collision_rightwall = false;
			collision_leftwall = true;
		} else if (obj.gameObject.name == "RightWall") {
			transform.position += Vector3.down * 20f * Time.deltaTime;
			collision_leftwall = false;
			collision_rightwall = true;
		} else if (obj.gameObject.tag == "lazer") {
			ScoreBoard.score += 10000;
			InvaderManager.numberInvaders--;
			Destroy (gameObject);
		}
	}

	void ShootLazer() {
		GetComponent<AudioSource> ().PlayOneShot (lazerAudio, 0.7f);
		Instantiate (enemyLazer, transform.position, transform.rotation);
	}

	void CheckDifficulty() {
		if (InvaderManager.numberInvaders <= 20 && !diffOne) {
			diffOne = true;
			speed += 1.0f;
		} else if (InvaderManager.numberInvaders <= 10 && !diffTwo) {
			diffTwo = true;
			speed += 1.0f;
		}
	}
}
